<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: /workplace/avs-device-sdk/ACL/src/Transport/MessageRequestHandler.cpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_b1dfedc9efa610ba8c818c30206ff41f.html">ACL</a></li><li class="navelem"><a class="el" href="dir_b7bc15c7de8e43583c698b7747a94971.html">src</a></li><li class="navelem"><a class="el" href="dir_7cc4805d13c57da402acac8e1a9ae866.html">Transport</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#namespaces">Namespaces</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">MessageRequestHandler.cpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;algorithm&gt;</code><br />
<code>#include &lt;functional&gt;</code><br />
<code>#include &lt;unordered_map&gt;</code><br />
<code>#include &lt;<a class="el" href="_http_response_code_8h_source.html">AVSCommon/Utils/HTTP/HttpResponseCode.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_h_t_t_p2_mime_request_encoder_8h_source.html">AVSCommon/Utils/HTTP2/HTTP2MimeRequestEncoder.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_h_t_t_p2_mime_response_decoder_8h_source.html">AVSCommon/Utils/HTTP2/HTTP2MimeResponseDecoder.h</a>&gt;</code><br />
<code>#include &lt;<a class="el" href="_logger_8h_source.html">AVSCommon/Utils/Logger/Logger.h</a>&gt;</code><br />
<code>#include &quot;<a class="el" href="_h_t_t_p2_transport_8h_source.html">ACL/Transport/HTTP2Transport.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_mime_response_sink_8h_source.html">ACL/Transport/MimeResponseSink.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="_message_request_handler_8h_source.html">ACL/Transport/MessageRequestHandler.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for MessageRequestHandler.cpp:</div>
<div class="dyncontent">
<div class="center"><img src="_message_request_handler_8cpp__incl.png" border="0" usemap="#_2workplace_2avs-device-sdk_2_a_c_l_2src_2_transport_2_message_request_handler_8cpp" alt=""/></div>
<map name="_2workplace_2avs-device-sdk_2_a_c_l_2src_2_transport_2_message_request_handler_8cpp" id="_2workplace_2avs-device-sdk_2_a_c_l_2src_2_transport_2_message_request_handler_8cpp">
<area shape="rect" id="node5" href="_http_response_code_8h.html" title="AVSCommon/Utils/HTTP\l/HttpResponseCode.h" alt="" coords="787,105,956,144"/>
<area shape="rect" id="node10" href="_logger_8h.html" title="AVSCommon/Utils/Logger\l/Logger.h" alt="" coords="806,279,982,317"/>
<area shape="rect" id="node22" href="_h_t_t_p2_mime_request_encoder_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeRequestEncoder.h" alt="" coords="1425,279,1635,317"/>
<area shape="rect" id="node26" href="_h_t_t_p2_mime_response_decoder_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeResponseDecoder.h" alt="" coords="4582,279,4803,317"/>
<area shape="rect" id="node30" href="_h_t_t_p2_transport_8h.html" title="ACL/Transport/HTTP2Transport.h" alt="" coords="2501,112,2722,137"/>
<area shape="rect" id="node47" href="_mime_response_sink_8h.html" title="ACL/Transport/MimeResponse\lSink.h" alt="" coords="3963,279,4167,317"/>
<area shape="rect" id="node50" href="_message_request_handler_8h.html" title="ACL/Transport/MessageRequest\lHandler.h" alt="" coords="3289,279,3504,317"/>
<area shape="rect" id="node8" href="_logger_utils_8h.html" title="AVSCommon/Utils/Logger\l/LoggerUtils.h" alt="" coords="781,192,957,231"/>
<area shape="rect" id="node15" href="_configuration_node_8h.html" title="AVSCommon/Utils/Configuration\l/ConfigurationNode.h" alt="" coords="743,365,957,404"/>
<area shape="rect" id="node18" href="_level_8h.html" title="AVSCommon/Utils/Logger\l/Level.h" alt="" coords="215,452,391,491"/>
<area shape="rect" id="node19" href="_log_entry_8h.html" title="AVSCommon/Utils/Logger\l/LogEntry.h" alt="" coords="391,365,567,404"/>
<area shape="rect" id="node20" href="_log_level_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/LogLevelObserverInterface.h" alt="" coords="69,365,266,404"/>
<area shape="rect" id="node21" href="_sink_observer_interface_8h.html" title="AVSCommon/Utils/Logger\l/SinkObserverInterface.h" alt="" coords="1183,365,1359,404"/>
<area shape="rect" id="node24" href="_h_t_t_p2_mime_request_source_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeRequestSourceInterface.h" alt="" coords="1960,365,2215,404"/>
<area shape="rect" id="node25" href="_h_t_t_p2_request_source_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2RequestSourceInterface.h" alt="" coords="1714,365,1936,404"/>
<area shape="rect" id="node28" href="_h_t_t_p2_mime_response_sink_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2MimeResponseSinkInterface.h" alt="" coords="4568,365,4817,404"/>
<area shape="rect" id="node29" href="_h_t_t_p2_response_sink_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2ResponseSinkInterface.h" alt="" coords="4405,452,4621,491"/>
<area shape="rect" id="node35" href="_attachment_manager_8h.html" title="AVSCommon/AVS/Attachment\l/AttachmentManager.h" alt="" coords="3964,365,4166,404"/>
<area shape="rect" id="node36" href="_h_t_t_p2_connection_interface_8h.html" title="AVSCommon/Utils/HTTP2\l/HTTP2ConnectionInterface.h" alt="" coords="3016,192,3214,231"/>
<area shape="rect" id="node37" href="_auth_delegate_interface_8h.html" title="AVSCommon/SDKInterfaces\l/AuthDelegateInterface.h" alt="" coords="3168,365,3359,404"/>
<area shape="rect" id="node38" href="_message_consumer_interface_8h.html" title="ACL/Transport/MessageConsumer\lInterface.h" alt="" coords="3485,365,3711,404"/>
<area shape="rect" id="node39" href="_ping_handler_8h.html" title="ACL/Transport/PingHandler.h" alt="" coords="2765,285,2960,311"/>
<area shape="rect" id="node41" href="_post_connect_factory_interface_8h.html" title="ACL/Transport/PostConnect\lFactoryInterface.h" alt="" coords="2583,192,2770,231"/>
<area shape="rect" id="node42" href="_post_connect_observer_interface_8h.html" title="ACL/Transport/PostConnect\lObserverInterface.h" alt="" coords="2322,192,2509,231"/>
<area shape="rect" id="node43" href="_post_connect_send_message_interface_8h.html" title="ACL/Transport/PostConnect\lSendMessageInterface.h" alt="" coords="2046,279,2233,317"/>
<area shape="rect" id="node45" href="_transport_interface_8h.html" title="ACL/Transport/TransportInterface.h" alt="" coords="2408,285,2639,311"/>
<area shape="rect" id="node46" href="_transport_observer_interface_8h.html" title="ACL/Transport/TransportObserver\lInterface.h" alt="" coords="2075,192,2297,231"/>
<area shape="rect" id="node40" href="_exchange_handler_8h.html" title="ACL/Transport/ExchangeHandler.h" alt="" coords="2815,372,3042,397"/>
<area shape="rect" id="node44" href="_message_request_8h.html" title="AVSCommon/AVS/MessageRequest.h" alt="" coords="2239,372,2488,397"/>
<area shape="rect" id="node48" href="_attachment_writer_8h.html" title="AVSCommon/AVS/Attachment\l/AttachmentWriter.h" alt="" coords="4241,365,4443,404"/>
<area shape="rect" id="node49" href="_mime_response_status_handler_interface_8h.html" title="ACL/Transport/MimeResponse\lStatusHandlerInterface.h" alt="" coords="3736,365,3940,404"/>
</map>
</div>
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr class="memitem:namespacealexa_client_s_d_k"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></td></tr>
<tr class="memdesc:namespacealexa_client_s_d_k"><td class="mdescLeft">&#160;</td><td class="mdescRight">Whether or not curl logs should be emitted. <br /></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:namespacealexa_client_s_d_k_1_1acl"><td class="memItemLeft" align="right" valign="top"> &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html">alexaClientSDK::acl</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="_message_request_handler_8cpp.html#ad8bc9ca8e55a0ebf538e46e28bf26262">LX</a>(event)&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td></tr>
<tr class="separator:ad8bc9ca8e55a0ebf538e46e28bf26262"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a65638c1fb9761b937511729e01aa5260"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a65638c1fb9761b937511729e01aa5260">alexaClientSDK::acl::TAG</a> (&quot;MessageRequestHandler&quot;)</td></tr>
<tr class="memdesc:a65638c1fb9761b937511729e01aa5260"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a65638c1fb9761b937511729e01aa5260">More...</a><br /></td></tr>
<tr class="separator:a65638c1fb9761b937511729e01aa5260"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a5da56b98323fc9c71a501d58c4d0cc0f"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a5da56b98323fc9c71a501d58c4d0cc0f">alexaClientSDK::acl::AVS_EVENT_URL_PATH_EXTENSION</a> = &quot;/v20160207/events&quot;</td></tr>
<tr class="memdesc:a5da56b98323fc9c71a501d58c4d0cc0f"><td class="mdescLeft">&#160;</td><td class="mdescRight">URL to send events to.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a5da56b98323fc9c71a501d58c4d0cc0f">More...</a><br /></td></tr>
<tr class="separator:a5da56b98323fc9c71a501d58c4d0cc0f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb214ab3bf72fedf80d9a0dca6e75e6e"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#afb214ab3bf72fedf80d9a0dca6e75e6e">alexaClientSDK::acl::MIME_BOUNDARY</a> = &quot;WhooHooZeerOoonie!&quot;</td></tr>
<tr class="memdesc:afb214ab3bf72fedf80d9a0dca6e75e6e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Boundary for mime encoded requests.  <a href="namespacealexa_client_s_d_k_1_1acl.html#afb214ab3bf72fedf80d9a0dca6e75e6e">More...</a><br /></td></tr>
<tr class="separator:afb214ab3bf72fedf80d9a0dca6e75e6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af4106be84e76e23a265df54dab0664e8"><td class="memItemLeft" align="right" valign="top">static const std::chrono::seconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#af4106be84e76e23a265df54dab0664e8">alexaClientSDK::acl::STREAM_PROGRESS_TIMEOUT</a> = std::chrono::seconds(30)</td></tr>
<tr class="memdesc:af4106be84e76e23a265df54dab0664e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Timeout for transmission of data on a given stream.  <a href="namespacealexa_client_s_d_k_1_1acl.html#af4106be84e76e23a265df54dab0664e8">More...</a><br /></td></tr>
<tr class="separator:af4106be84e76e23a265df54dab0664e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cf744b87417d0057120aa90816ef1cb"><td class="memItemLeft" align="right" valign="top">static const std::vector&lt; std::string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a7cf744b87417d0057120aa90816ef1cb">alexaClientSDK::acl::JSON_MIME_PART_HEADER_LINES</a></td></tr>
<tr class="memdesc:a7cf744b87417d0057120aa90816ef1cb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mime header strings for mime parts containing json payloads.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a7cf744b87417d0057120aa90816ef1cb">More...</a><br /></td></tr>
<tr class="separator:a7cf744b87417d0057120aa90816ef1cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f526b374ab33a3bbec7c2024da20c58"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a6f526b374ab33a3bbec7c2024da20c58">alexaClientSDK::acl::CONTENT_DISPOSITION_PREFIX</a> = &quot;Content-Disposition: form-data; name=\&quot;&quot;</td></tr>
<tr class="memdesc:a6f526b374ab33a3bbec7c2024da20c58"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mime Content-Disposition line before name.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a6f526b374ab33a3bbec7c2024da20c58">More...</a><br /></td></tr>
<tr class="separator:a6f526b374ab33a3bbec7c2024da20c58"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ba067e0455099df272e61fb223efe0d"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a2ba067e0455099df272e61fb223efe0d">alexaClientSDK::acl::CONTENT_DISPOSITION_SUFFIX</a> = &quot;\&quot;&quot;</td></tr>
<tr class="memdesc:a2ba067e0455099df272e61fb223efe0d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mime Content-Disposition line after name.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a2ba067e0455099df272e61fb223efe0d">More...</a><br /></td></tr>
<tr class="separator:a2ba067e0455099df272e61fb223efe0d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac10faf1e5bf481dd7a953a82de016742"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#ac10faf1e5bf481dd7a953a82de016742">alexaClientSDK::acl::ATTACHMENT_CONTENT_TYPE</a> = &quot;Content-Type: application/octet-stream&quot;</td></tr>
<tr class="memdesc:ac10faf1e5bf481dd7a953a82de016742"><td class="mdescLeft">&#160;</td><td class="mdescRight">Mime Content-Type for attchments.  <a href="namespacealexa_client_s_d_k_1_1acl.html#ac10faf1e5bf481dd7a953a82de016742">More...</a><br /></td></tr>
<tr class="separator:ac10faf1e5bf481dd7a953a82de016742"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4f01bd45ef0ebf04b5fd233f7f950221"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1acl.html#a4f01bd45ef0ebf04b5fd233f7f950221">alexaClientSDK::acl::MESSAGEREQUEST_ID_PREFIX</a> = &quot;AVSEvent-&quot;</td></tr>
<tr class="memdesc:a4f01bd45ef0ebf04b5fd233f7f950221"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prefix for the ID of message requests.  <a href="namespacealexa_client_s_d_k_1_1acl.html#a4f01bd45ef0ebf04b5fd233f7f950221">More...</a><br /></td></tr>
<tr class="separator:a4f01bd45ef0ebf04b5fd233f7f950221"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ad8bc9ca8e55a0ebf538e46e28bf26262"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad8bc9ca8e55a0ebf538e46e28bf26262">&#9670;&nbsp;</a></span>LX</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LX</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">event</td><td>)</td>
          <td>&#160;&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1logger_1_1_log_entry.html">alexaClientSDK::avsCommon::utils::logger::LogEntry</a>(<a class="el" href="_u_i_manager_8cpp.html#ada5473a95becdcf63a8f83e7f05fefe7">TAG</a>, event)</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Create a LogEntry using this file's TAG and the specified event string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td>event string for this <code>LogEntry</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
